// Self includes
#include "mainwindow.h"

// <QtWidgets> includes
#include <QTableView>
#include <QHeaderView>


TableModel::TableModel(QObject *const parent)
    : QAbstractTableModel(parent)
{
}


QVariant TableModel::data(const QModelIndex &index, int role) const
{
    if (index.isValid() && role == Qt::DisplayRole)
        return _buffer.at(index.row());

    return QVariant();
}



QVariant TableModel::headerData(int section, Qt::Orientation orientation, int role) const
{
    if (role != Qt::DisplayRole)
        return QVariant();

    if (orientation == Qt::Horizontal)
        return "test column";
    else
        return section;
}


void TableModel::addData()
{
    QVector<int> testData(10000);

    beginInsertRows(QModelIndex(), rowCount(), rowCount() + testData.count() - 1);
    _buffer = testData;
    endInsertRows();
}


MainWindow::MainWindow(QWidget *parent)
    : QMainWindow(parent)
{
    TableModel  *const model(new TableModel(this));
    QTableView  *const view(new QTableView());

    view->verticalHeader()->setDefaultSectionSize(18);
    view->setModel(model);
    setCentralWidget(view);

    model->addData();
}


MainWindow::~MainWindow()
{    
}
