#ifndef MAINWINDOW_H
#define MAINWINDOW_H

// <QtCore> includes
#include <QVector>
#include <QAbstractTableModel>

// <QtWidgets> includes
#include <QMainWindow>


class TableModel : public QAbstractTableModel
{
    Q_OBJECT

public:
    TableModel(QObject *const parent = 0);

    int rowCount(const QModelIndex &parent = QModelIndex()) const;
    int columnCount(const QModelIndex &parent = QModelIndex()) const;
    QVariant data(const QModelIndex &index, int role = Qt::DisplayRole) const;
    QVariant headerData(int section, Qt::Orientation orientation, int role = Qt::DisplayRole) const;

    void addData();

private:
    QVector<int> _buffer;
};


inline int TableModel::rowCount(const QModelIndex & /*parent*/) const
{
    return _buffer.count();
}


inline int TableModel::columnCount(const QModelIndex & /*parent*/) const
{
    return 1;
}


class MainWindow : public QMainWindow
{
    Q_OBJECT
    
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();
};

#endif // MAINWINDOW_H
